/**
 * Use this file for JavaScript code that you want to run in the front-end
 * on posts/pages that contain this block.
 *
 * When this file is defined as the value of the `viewScript` property
 * in `block.json` it will be enqueued on the front end of the site.
 *
 * Example:
 *
 * ```js
 * {
 *   "viewScript": "file:./view.js"
 * }
 * ```
 *
 * If you're not making any changes to this file because your project doesn't need any
 * JavaScript running in the front-end, then you should delete this file and remove
 * the `viewScript` property from `block.json`.
 *
 * @see https://developer.wordpress.org/block-editor/reference-guides/block-api/block-metadata/#view-script
 */

// eslint-disable-next-line import/no-unresolved
import 'https://cdn.jsdelivr.net/gh/locr-company/Leaflet.GridLayer.VMS2@5241120/src/LocrMapCustomElement.js';

const apiFetchHandler = window.wp?.apiFetch || window.wp?.apiRequest;
if ( ! apiFetchHandler ) {
	throw new Error( 'No API fetch handler found!' );
}

const path = `/locrmaps/settings/all-options`;
apiFetchHandler( { path } ).then( ( response ) => {
	if ( response?.general ) {
		if (
			typeof response.general[ 'access-key' ] === 'string' &&
			response.general[ 'access-key' ].length > 0
		) {
			const locrMapElements = document.querySelectorAll( 'locr-map' );
			locrMapElements.forEach( ( locrMapElement ) => {
				locrMapElement.setAttribute(
					'access-key',
					response.general[ 'access-key' ]
				);
			} );
		}
	}
} );
